SystemOrganization addCategory: #'Compiler-Frontend'!

!Text methodsFor: '*compiler-frontend-deprecated' stamp: 'EstebanAllende 11/28/2011 00:03'!
makeSelectorBold
	"For formatting Smalltalk source code, set the emphasis of that portion of 
	the receiver's string that parses as a message selector to be bold."

	^self
	"| parser i |
	string size = 0 ifTrue: [^ self].
	i := 0.
	[(string at: (i := i + 1)) isSeparator] whileTrue.
	(string at: i) = $[ ifTrue: [^ self]. " "block, no selector" "
	[(parser := self class evaluatorClass parserClass new) parseSelector: string] on: Error do: [^ self].
	self makeBoldFrom: 1 to: (parser endOfLastToken min: string size)"! !

!Text methodsFor: '*compiler-frontend-deprecated' stamp: 'EstebanAllende 11/28/2011 00:03'!
makeSelectorBoldIn: aClass
	"For formatting Smalltalk source code, set the emphasis of that portion of 
	the receiver's string that parses as a message selector to be bold."
	
	^self
	"| parser |
	string size = 0 ifTrue: [^self].
	(parser := aClass parserClass new) parseSelector: string.
	self makeBoldFrom: 1 to: (parser endOfLastToken min: string size)"! !

Object subclass: #CompiledMethodWithNode
	instanceVariableNames: 'node method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Frontend'!

!CompiledMethodWithNode class methodsFor: 'instance creation' stamp: 'NS 1/28/2004 09:05'!
generateMethodFromNode: aMethodNode trailer: bytes
	^ self method: (aMethodNode generate: bytes) node: aMethodNode.! !

!CompiledMethodWithNode class methodsFor: 'instance creation' stamp: 'NS 1/28/2004 09:05'!
method: aCompiledMethod node: aMethodNode
	^ self new method: aCompiledMethod; node: aMethodNode.! !

!CompiledMethodWithNode methodsFor: 'accessing' stamp: 'NS 1/28/2004 09:03'!
method
	^ method! !

!CompiledMethodWithNode methodsFor: 'private' stamp: 'NS 1/28/2004 09:03'!
method: aCompiledMethod
	method := aCompiledMethod! !

!CompiledMethodWithNode methodsFor: 'accessing' stamp: 'NS 1/28/2004 09:04'!
node
	^ node! !

!CompiledMethodWithNode methodsFor: 'private' stamp: 'NS 1/28/2004 09:04'!
node: aMethodNode
	node := aMethodNode! !

!CompiledMethodWithNode methodsFor: 'accessing' stamp: 'NS 1/28/2004 09:04'!
selector
	^ self node selector! !

Object subclass: #CompilerContext
	instanceVariableNames: 'styler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Frontend'!

!CompilerContext methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 12:19'!
compiler
	^CompilerFrontend compilerNamed: self compilerName! !

!CompilerContext methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 12:18'!
compilerName
	^self subclassResponsibility! !

!CompilerContext methodsFor: 'accessing' stamp: 'EstebanAllende 11/29/2011 17:50'!
defaultStyler

	^ self subclassResponsibility.! !

!CompilerContext methodsFor: 'accessing' stamp: 'EstebanAllende 11/29/2011 22:56'!
styler

	^ styler ifNil: [styler := self defaultStyler].! !

!CompilerContext methodsFor: 'accessing' stamp: 'EstebanAllende 11/29/2011 17:49'!
styler: anObject

	styler := anObject! !

Object subclass: #CompilerFrontend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Frontend'!

CompilerFrontend class
	instanceVariableNames: 'registeredCompilers defaultCompilerFrontend defaultEvaluatorFrontend compilerContextForClass'!

CompilerFrontend class
	instanceVariableNames: 'registeredCompilers defaultCompilerFrontend defaultEvaluatorFrontend compilerContextForClass'!

!CompilerFrontend class methodsFor: 'accessing' stamp: 'EstebanAllende 11/29/2011 15:46'!
compilerContextForClass: aClass
	((aClass = nil) | (aClass = UndefinedObject)) ifTrue: [^(self compilerNamed: self defaultEvaluatorFrontend) defaultCompilerContext].
	^compilerContextForClass at: aClass ifAbsent: [
		|method|
		method := aClass theMetaClass lookupSelector: #compilerContext.
		method ifNotNil: [(method pragmaAt: #original) ifNil: [aClass isTrait ifFalse: [^aClass theNonMetaClass compilerContext]]].
		(self compilerNamed: self defaultCompilerFrontend) defaultCompilerContext.
	].
! !

!CompilerFrontend class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 12:25'!
compilerNamed: aSymbol
	^registeredCompilers at: aSymbol.
	! !

!CompilerFrontend class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 11:18'!
defaultCompilerFrontend

	^ defaultCompilerFrontend! !

!CompilerFrontend class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 11:18'!
defaultCompilerFrontend: anObject

	defaultCompilerFrontend := anObject! !

!CompilerFrontend class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 16:55'!
defaultEvaluatorFrontend

	^ defaultEvaluatorFrontend! !

!CompilerFrontend class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 16:55'!
defaultEvaluatorFrontend: anObject

	defaultEvaluatorFrontend := anObject! !

!CompilerFrontend class methodsFor: 'class initialization' stamp: 'EstebanAllende 11/27/2011 15:26'!
initialize
	registeredCompilers := Dictionary new.
	compilerContextForClass := IdentityDictionary new.
	! !

!CompilerFrontend class methodsFor: 'compiler management' stamp: 'EstebanAllende 11/27/2011 12:13'!
registerCompiler: aSymbol as: aCompilerFrontend 
	registeredCompilers at: aSymbol put: aCompilerFrontend.
	! !

!CompilerFrontend class methodsFor: 'compiler management' stamp: 'EstebanAllende 11/27/2011 12:13'!
registerCompilerContext: aCompilerContext forClass: aClass 
	compilerContextForClass at: aClass put: aCompilerContext
	
	! !

!CompilerFrontend class methodsFor: 'compiler management' stamp: 'EstebanAllende 11/27/2011 12:13'!
unregisterCompiler: aSymbol
	registeredCompilers removeKey: aSymbol.
	! !

!CompilerFrontend class methodsFor: 'compiler management' stamp: 'EstebanAllende 11/27/2011 12:14'!
unregisterCompilerContextForClass: aClass 
	compilerContextForClass removeKey: aClass.
	
	! !

!CompilerFrontend methodsFor: 'backward compatibility' stamp: 'EstebanAllende 11/27/2011 14:45'!
bcCompilerClass
	^self subclassResponsibility! !

!CompilerFrontend methodsFor: 'backward compatibility' stamp: 'EstebanAllende 11/27/2011 14:03'!
bcDecompilerClass
	^self subclassResponsibility! !

!CompilerFrontend methodsFor: 'backward compatibility' stamp: 'EstebanAllende 11/27/2011 14:04'!
bcEvaluatorClass
	^self subclassResponsibility! !

!CompilerFrontend methodsFor: 'backward compatibility' stamp: 'EstebanAllende 12/13/2011 14:11'!
bcMethodMapper
	^self subclassResponsibility! !

!CompilerFrontend methodsFor: 'backward compatibility' stamp: 'EstebanAllende 11/27/2011 14:03'!
bcParserClass
	^self subclassResponsibility! !

!CompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 16:10'!
defaultCompilerContext
	
	^self subclassResponsibility! !

!CompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/23/2011 13:03'!
evaluator
	^self subclassResponsibility! !

!CompilerFrontend methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/23/2011 12:54'!
methodCompiler
	^self subclassResponsibility! !

Object subclass: #MethodCompilerFrontend
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Frontend'!

!MethodCompilerFrontend class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 13:41'!
compatibilityOldCompilerClass
	^self subclassResponsibility.! !

!MethodCompilerFrontend class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/14/2011 11:54'!
defaultCompilerContext
	
	^self subclassResponsibility.! !

!MethodCompilerFrontend methodsFor: 'compiling' stamp: 'EstebanAllende 10/26/2011 22:55'!
compileWithRequest: aCompileRequest usingCompilerContext: aCompilerContext

	^self subclassResponsibility! !

!MethodCompilerFrontend methodsFor: 'compiling' stamp: 'EstebanAllende 12/23/2011 15:37'!
evaluateWithRequest: aCompileRequest usingCompilerContext: aCompilerContext

	^self subclassResponsibility! !

!MethodCompilerFrontend methodsFor: 'compiling' stamp: 'EstebanAllende 12/13/2011 14:41'!
mapActiveContextToSource: aContext

	^self subclassResponsibility! !

!MethodCompilerFrontend methodsFor: 'compiling' stamp: 'EstebanAllende 12/13/2011 14:41'!
mapPasiveContextToSource: aContext

	^self subclassResponsibility! !

!MethodCompilerFrontend methodsFor: 'compiling' stamp: 'EstebanAllende 11/27/2011 22:13'!
parseWithRequest: aCompileRequest usingCompilerContext: aCompilerContext

	^self subclassResponsibility! !

!TPureBehavior methodsFor: '*compiler-frontend' stamp: 'EstebanAllende 11/27/2011 21:36'!
compilerContext
	<original> "Unless you want a frozen system, don't delete or change this pragma"
	^ CompilerFrontend compilerContextForClass: self! !

!UndefinedObject methodsFor: '*compiler-frontend' stamp: 'EstebanAllende 11/29/2011 15:46'!
compilerContext
	<original> "For consistency"
	^CompilerFrontend compilerContextForClass: nil.! !

!UndefinedObject methodsFor: '*compiler-frontend' stamp: 'EstebanAllende 12/6/2011 23:54'!
printAsIfCompiledOn: aStream
	"Warning: HACK"
	^self printOn: aStream! !
CompilerFrontend initialize!
